%define anolis_release 2

%bcond_without check

Name:           rust-packaging
Version:        26.2
Release:        %{anolis_release}%{?dist}
Summary:        RPM macros and generators for building Rust packages
License:        MIT

URL:            https://pagure.io/fedora-rust/rust-packaging
Source:         %{url}/archive/%{version}/rust-packaging-%{version}.tar.gz

Patch0:         0001-Temporarily-accept-cargo_prep-V-flag-for-spec-compat.patch

Patch1:         1000-fix-pytest-error.patch
Patch2:		0001-add-loongarch64-support-for-rust-packaging.patch

BuildArch:      noarch

%if %{with check}
BuildRequires:  python3-pytest
%endif

%description
%{summary}.

%package -n rust-srpm-macros
Summary:        RPM macros for building Rust projects

%description -n rust-srpm-macros
RPM macros for building source packages for Rust projects.

%package -n cargo-rpm-macros
Summary:        RPM macros for building projects with cargo

Obsoletes:      rust-packaging < 24
Provides:       rust-packaging = %{version}-%{release}

Requires:       cargo2rpm >= 0.1.8

Requires:       cargo
Requires:       gawk
Requires:       grep

Requires:       rust-srpm-macros = %{version}-%{release}

%description -n cargo-rpm-macros
RPM macros for building projects with cargo.

%prep
%autosetup -p1

%build
# nothing to do

%install
install -D -p -m 0644 -t %{buildroot}/%{_rpmmacrodir} macros.d/macros.cargo
install -D -p -m 0644 -t %{buildroot}/%{_rpmmacrodir} macros.d/macros.rust
install -D -p -m 0644 -t %{buildroot}/%{_rpmmacrodir} macros.d/macros.rust-srpm
install -D -p -m 0644 -t %{buildroot}/%{_fileattrsdir} fileattrs/cargo.attr
install -D -p -m 0644 -t %{buildroot}/%{_fileattrsdir} fileattrs/cargo_vendor.attr

%if %{with check}
%check
export MACRO_DIR=%{buildroot}%{_rpmmacrodir}
pytest -vv
%endif

%files -n rust-srpm-macros
%license LICENSE
%{_rpmmacrodir}/macros.rust
%{_rpmmacrodir}/macros.rust-srpm

%files -n cargo-rpm-macros
%license LICENSE
%{_rpmmacrodir}/macros.cargo
%{_rpmmacrodir}/macros.rust
%{_fileattrsdir}/cargo.attr
%{_fileattrsdir}/cargo_vendor.attr

%changelog
* Mon Aug  5 2024 Wenlong Zhang <zhangwenlong@loongson.cn> - 26.2-2
- add loongarch64 support for rust-packaging

* Fri Apr 12 2024 mgb01105731 <mgb01105731@alibaba-inc.com> - 26.2-1
- Update to version 26.2

* Wed Mar 13 2024 Zhao Hang <wb-zh951434@alibaba-inc.com> - 1:23-2
- Rebuild with python3.11
- update Copyright date

* Tue Feb 14 2023 Funda Wang <fundawang@yeah.net> - 1:23-1
- New version 23

* Wed Apr 20 2022 happy_orange <songnannan@linux.alibaba.com> - 1:21-1
- Init package from upstream
